> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List user actions

> Retrieve user action log for one client or a set of projects



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml get /cloud/v1/user_actions
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-15T06:37:28.230198+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/user_actions:
    get:
      tags:
        - User Actions
      summary: List user actions
      description: Retrieve user action log for one client or a set of projects
      operationId: UserActionLogClientViewSet.get
      parameters:
        - in: query
          name: action_type
          required: false
          description: User action type. Several options can be specified.
          schema:
            description: User action type. Several options can be specified.
            example:
              - activate
              - delete
            examples:
              - - activate
                - delete
            items:
              $ref: '#/components/schemas/cloud_ActionType'
            title: Action Type
            type: array
        - in: query
          name: api_group
          required: false
          description: >-
            API group that requested action belongs to. Several options can be
            specified.
          schema:
            description: >-
              API group that requested action belongs to. Several options can be
              specified.
            example:
              - ai_cluster
              - image
            examples:
              - - ai_cluster
                - image
            items:
              enum:
                - ai_cluster
                - caas_container
                - caas_key
                - caas_pull_secret
                - dbaas_postgres
                - ddos_profile
                - faas_function
                - faas_key
                - faas_namespace
                - file_shares
                - floating_ip
                - image
                - inference_at_the_edge
                - instance
                - instance_isolation
                - k8s_cluster
                - k8s_cluster_template
                - k8s_pool
                - laas
                - laas_topic
                - lb_health_monitor
                - lb_l7policy
                - lb_l7rule
                - lblistener
                - lbpool
                - lbpool_member
                - lifecycle_policy
                - lifecycle_policy_volume_member
                - loadbalancer
                - network
                - port
                - project
                - quota_limit_request
                - registry
                - reservation
                - reserved_fixed_ip
                - role
                - router
                - secret
                - securitygroup
                - securitygrouprule
                - servergroup
                - shared_flavor
                - shared_image
                - shared_network
                - snapshot
                - snapshot_schedule
                - ssh_key
                - subnet
                - user
                - vip_ip_addresses
                - volume
              type: string
            title: Api Group
            type: array
        - in: query
          name: from_timestamp
          required: false
          description: >-
            ISO formatted datetime string. Starting timestamp from which user
            actions are requested
          schema:
            description: >-
              ISO formatted datetime string. Starting timestamp from which user
              actions are requested
            example: '2019-11-14T10:30:32Z'
            examples:
              - '2019-11-14T10:30:32Z'
            format: date-time
            title: From Timestamp
            type: string
        - in: query
          name: limit
          required: false
          description: Optional. Limit the number of returned items
          schema:
            default: 1000
            description: Optional. Limit the number of returned items
            example: 1000
            examples:
              - 1000
            exclusiveMinimum: 0
            maximum: 1000
            title: Limit
            type: integer
        - in: query
          name: offset
          required: false
          description: >-
            Optional. Offset value is used to exclude the first set of records
            from the result
          schema:
            default: 0
            description: >-
              Optional. Offset value is used to exclude the first set of records
              from the result
            example: 0
            examples:
              - 0
            minimum: 0
            title: Offset
            type: integer
        - in: query
          name: order_by
          required: false
          description: Sorting by timestamp. Oldest first, or most recent first
          schema:
            $ref: '#/components/schemas/UserActionOrderByChoices'
            default: desc
            description: Sorting by timestamp. Oldest first, or most recent first
            examples:
              - asc
        - in: query
          name: project_id
          required: false
          description: Project ID. Several options can be specified.
          schema:
            description: Project ID. Several options can be specified.
            example:
              - 1
              - 2
              - 3
            examples:
              - - 1
                - 2
                - 3
            items:
              format: int64
              type: integer
            title: Project Id
            type: array
        - in: query
          name: region_id
          required: false
          description: Region ID. Several options can be specified.
          schema:
            description: Region ID. Several options can be specified.
            example:
              - 1
              - 2
              - 3
            examples:
              - - 1
                - 2
                - 3
            items:
              format: int64
              type: integer
            title: Region Id
            type: array
        - in: query
          name: resource_id
          required: false
          description: Resource ID. Several options can be specified.
          schema:
            description: Resource ID. Several options can be specified.
            items:
              type: string
            title: Resource Id
            type: array
        - in: query
          name: search_field
          required: false
          description: >-
            Extra search field for common object properties such as name, IP
            address, or other, depending on the `resource_type`
          schema:
            description: >-
              Extra search field for common object properties such as name, IP
              address, or other, depending on the `resource_type`
            example: default
            examples:
              - default
            title: Search Field
            type: string
        - in: query
          name: sorting
          required: false
          description: >-
            (DEPRECATED Use 'order_by' instead) Sorting by timestamp. Oldest
            first, or most recent first
          schema:
            $ref: '#/components/schemas/UserActionOrderByChoices'
            default: desc
            deprecated: true
            description: >-
              (DEPRECATED Use 'order_by' instead) Sorting by timestamp. Oldest
              first, or most recent first
            examples:
              - asc
        - in: query
          name: source_user_ips
          required: false
          description: >-
            Originating IP address of the client making the request. Several
            options can be specified.
          schema:
            description: >-
              Originating IP address of the client making the request. Several
              options can be specified.
            example:
              - 203.0.113.42
              - 192.168.1.100
            examples:
              - - 203.0.113.42
                - 192.168.1.100
            items:
              type: string
            title: Source User Ips
            type: array
        - in: query
          name: to_timestamp
          required: false
          description: >-
            ISO formatted datetime string. Ending timestamp until which user
            actions are requested
          schema:
            description: >-
              ISO formatted datetime string. Ending timestamp until which user
              actions are requested
            example: '2019-11-14T10:30:32Z'
            examples:
              - '2019-11-14T10:30:32Z'
            format: date-time
            title: To Timestamp
            type: string
        - in: query
          name: user_agents
          required: false
          description: >-
            User-Agent string identifying the client making the request. Several
            options can be specified.
          schema:
            description: >-
              User-Agent string identifying the client making the request.
              Several options can be specified.
            example:
              - Mozilla/5.0
              - MyApp/1.0.0
            examples:
              - - Mozilla/5.0
                - MyApp/1.0.0
            items:
              type: string
            title: User Agents
            type: array
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UserActionCollectionSerializer'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            page = client.cloud.audit_logs.list()
            page = page.results[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Cloud.AuditLogs.List(context.TODO(), cloud.AuditLogListParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    cloud_ActionType:
      enum:
        - activate
        - attach
        - change_logging_resources
        - create
        - create_access_rule
        - deactivate
        - delete
        - delete_access_rule
        - delete_metadata
        - detach
        - disable_logging
        - disable_portsecurity
        - download
        - enable_logging
        - enable_portsecurity
        - failover
        - put_into_servergroup
        - reboot
        - reboot_hard
        - rebuild
        - regenerate_credentials
        - remove_from_servergroup
        - replace
        - replace_metadata
        - resize
        - resume
        - retype
        - revert
        - scale_down
        - scale_up
        - start
        - stop
        - suspend
        - update
        - update_metadata
        - upgrade
      title: ActionType
      type: string
    UserActionOrderByChoices:
      enum:
        - asc
        - desc
      title: UserActionOrderByChoices
      type: string
    UserActionCollectionSerializer:
      properties:
        count:
          description: Number of objects
          example: 1
          examples:
            - 1
          minimum: 0
          title: Count
          type: integer
        results:
          description: Objects
          items:
            $ref: '#/components/schemas/UserActionSerializer'
          title: Results
          type: array
      required:
        - count
        - results
      title: UserActionCollectionSerializer
      type: object
    UserActionSerializer:
      properties:
        acknowledged:
          description: >-
            User action log was successfully received by its subscriber in case
            there is one
          example: true
          examples:
            - true
          title: Acknowledged
          type: boolean
        action_data:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          description: Additional information about the action
          examples:
            - '{"name": "test_project_a"}'
          title: Action Data
        action_type:
          $ref: '#/components/schemas/cloud_ActionType'
          description: Action type
          examples:
            - create
        api_group:
          description: API group
          enum:
            - ai_cluster
            - caas_container
            - caas_key
            - caas_pull_secret
            - dbaas_postgres
            - ddos_profile
            - faas_function
            - faas_key
            - faas_namespace
            - file_shares
            - floating_ip
            - image
            - inference_at_the_edge
            - instance
            - instance_isolation
            - k8s_cluster
            - k8s_cluster_template
            - k8s_pool
            - laas
            - laas_topic
            - lb_health_monitor
            - lb_l7policy
            - lb_l7rule
            - lblistener
            - lbpool
            - lbpool_member
            - lifecycle_policy
            - lifecycle_policy_volume_member
            - loadbalancer
            - network
            - port
            - project
            - quota_limit_request
            - registry
            - reservation
            - reserved_fixed_ip
            - role
            - router
            - secret
            - securitygroup
            - securitygrouprule
            - servergroup
            - shared_flavor
            - shared_image
            - shared_network
            - snapshot
            - snapshot_schedule
            - ssh_key
            - subnet
            - user
            - vip_ip_addresses
            - volume
          example: project
          examples:
            - project
          type: string
        client_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Client ID of the user.
          examples:
            - 10
          title: Client Id
        email:
          anyOf:
            - format: email
              type: string
            - type: 'null'
          description: User email address
          examples:
            - user@example.com
          title: Email
        id:
          description: User action ID
          example: '123'
          examples:
            - '123'
          title: Id
          type: string
        is_complete:
          description: >-
            User action was filled with all necessary information. If false,
            then something went wrong during user action creation or update
          example: true
          examples:
            - true
          title: Is Complete
          type: boolean
        issued_by_user_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: User ID who issued the token that made the request
          examples:
            - 222324
          title: Issued By User Id
        project_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Project ID
          examples:
            - 1
          title: Project Id
        region_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Region ID
          examples:
            - 4
          title: Region Id
        resources:
          description: Resources
          items:
            $ref: '#/components/schemas/UserActionResourceSerializer'
          title: Resources
          type: array
        source_user_ip:
          anyOf:
            - type: string
            - type: 'null'
          description: User IP that made the request
          examples:
            - 1.2.3.4
          title: Source User Ip
        task_id:
          anyOf:
            - type: string
            - type: 'null'
          description: Task ID
          examples:
            - 1bdcc138-e716-41ff-ad8d-3477a7ac6d14
          title: Task Id
        timestamp:
          description: Datetime. Action timestamp
          example: '2019-11-14T10:30:32+00:00'
          examples:
            - '2019-11-14T10:30:32+00:00'
          format: date-time
          title: Timestamp
          type: string
        token_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Token ID
          examples:
            - 192021
          title: Token Id
        total_price:
          anyOf:
            - $ref: '#/components/schemas/UserActionResourcePriceSerializer'
            - type: 'null'
          description: Total resource price VAT inclusive
        user_agent:
          anyOf:
            - type: string
            - type: 'null'
          description: User-Agent that made the request
          examples:
            - Mozilla/5.0
          title: User Agent
        user_id:
          description: User ID
          example: 789
          examples:
            - 789
          title: User Id
          type: integer
      required:
        - id
        - timestamp
        - client_id
        - user_id
        - email
        - project_id
        - region_id
        - api_group
        - action_type
        - action_data
        - task_id
        - user_agent
        - source_user_ip
        - acknowledged
        - is_complete
        - total_price
        - token_id
        - issued_by_user_id
        - resources
      title: UserAction schema
      type: object
    UserActionResourceSerializer:
      properties:
        resource_body:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          default: null
          description: Free-form object, resource body.
          examples:
            - key: value
          title: Resource Body
        resource_id:
          description: Resource ID
          example: '1234'
          examples:
            - '1234'
          title: Resource Id
          type: string
        resource_type:
          description: Resource type
          enum:
            - caas_container
            - caas_key
            - caas_pull_secret
            - dbaas_postgres
            - ddos_profile
            - external_ip
            - faas_function
            - faas_key
            - faas_namespace
            - file_shares
            - floating_ip
            - gpu_baremetal_server
            - gpu_virtual_server
            - gpuai_cluster
            - image
            - inference_api_key
            - inference_application
            - inference_instance
            - inference_registry_credentials
            - inference_secret
            - instance
            - ipu_cluster
            - k8s_cluster
            - k8s_cluster_template
            - k8s_pool
            - laas
            - laas_topic
            - lb_health_monitor
            - lb_l7policy
            - lb_l7rule
            - lblistener
            - lbpool
            - lbpool_member
            - lifecycle_policy
            - lifecycle_policy_volume_member
            - loadbalancer
            - network
            - port
            - project
            - quota_limit_request
            - registry
            - registry_repository
            - registry_repository_artifact
            - registry_repository_tag
            - registry_user
            - registry_user_sercret
            - reservation
            - role
            - router
            - secret
            - securitygroup
            - securitygrouprule
            - servergroup
            - shared_flavor
            - shared_image
            - shared_network
            - snapshot
            - snapshot_schedule
            - ssh_key
            - subnet
            - token
            - user
            - virtual_gpu_cluster
            - volume
          example: project
          examples:
            - project
          type: string
        search_field:
          anyOf:
            - type: string
            - type: 'null'
          default: null
          description: >-
            Often used property for filtering actions. It can be a name, IP
            address, or other property, depending on the `resource_type`
          examples:
            - name
            - 192.168.0.1
          title: Search Field
      required:
        - resource_id
        - resource_type
      title: UserActionResource schema
      type: object
    UserActionResourcePriceSerializer:
      properties:
        currency_code:
          anyOf:
            - type: string
            - type: 'null'
          description: Currency code (3 letter code per ISO 4217)
          examples:
            - USD
          title: Currency Code
        price_per_hour:
          anyOf:
            - type: number
            - type: 'null'
          description: Total price VAT inclusive per hour
          examples:
            - 0.01
          title: Price Per Hour
        price_per_month:
          anyOf:
            - type: number
            - type: 'null'
          description: Total price VAT inclusive per month (30 days)
          examples:
            - 7.2
          title: Price Per Month
        price_status:
          $ref: '#/components/schemas/PriceDisplayStatus'
          description: Price status for the UI
          examples:
            - show
      required:
        - currency_code
        - price_per_hour
        - price_per_month
        - price_status
      title: UserActionResourcePrice schema
      type: object
    PriceDisplayStatus:
      enum:
        - error
        - hide
        - show
      title: PriceDisplayStatus
      type: string
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````